/* 
   FBBlobHandle.m

   Copyright (C) 1999 MDlink online service center GmbH and Helge Hess

   Author: Helge Hess (helge.hess@mdlink.de)

   This file is part of the FB Adaptor Library

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
// $Id: FBBlobHandle.m,v 1.2 1999/11/02 23:32:39 helge Exp $

#include "FBBlobHandle.h"
#include <FBCAccess/FBCAccess.h>
#import <Foundation/Foundation.h>

@implementation FBBlobHandle

- (id)initWithHandle:(NSString *)_handle {
  if ((self->handle = fbcbhInitWithHandle((char *)[_handle cString])) == NULL) {
    NSLog(@"Couldn't create BLOB handle %@", _handle);
    RELEASE(self);
    return nil;
  }
  self->handleId = RETAIN(_handle);
  return self;
}

- (id)initWithCBlob:(void *)cBlob {
  if (cBlob == NULL) {
    NSLog(@"Missing C-BLOB handle ..");
    RELEASE(self);
    return nil;
  }
  self->handle = cBlob;
  return self;
}

- (void)dealloc {
  if (self->handle) {
    fbcbhRelease(self->handle);
    self->handle = NULL;
  }
  RELEASE(self->handleId);
  [super dealloc];
}

- (void *)cBlobHandle {
  return self->handle;
}

- (void)getHandle:(NSString *)_handle {
  fbcbhGetHandle(self->handle, (char *)[_handle cString]);
}

- (unsigned)blobSize {
  return fbcbhBlobSize(self->handle);
}

- (NSString *)blobDescription {
  char *d;

  if ((d = fbcbhDescription(self->handle)))
    return [NSString stringWithCString:d];
  else
    return nil;
}

@end /* FBBlobHandle */
