/* 
   FBDatabaseConnection.h

   Copyright (C) 1999 MDlink online service center GmbH and Helge Hess

   Author: Helge Hess (helge.hess@mdlink.de)

   This file is part of the FB Adaptor Library

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
// $Id: FBDatabaseConnection.h,v 1.2 1999/11/02 23:32:40 helge Exp $

#ifndef __FrontBase_FBDatabaseConnection_H__
#define __FrontBase_FBDatabaseConnection_H__

#import <Foundation/NSObject.h>

@class NSValue, NSString;
@class FBMetaData, FBBlobHandle;

@interface FBDatabaseConnection : NSObject
{
  void *fb;
}

- (BOOL)setRollbackAfterError:(BOOL)_flag;

/* connection */

- (void)connectToDatabaseNamed:(NSString *)_db;
- (void)connectToDatabaseNamed:(NSString *)_db onHost:(NSString *)_hostName;
- (void)connectToDatabaseNamed:(NSString *)_db onHost:(NSString *)_hostName
  password:(NSString *)_dbPwd;

- (FBMetaData *)disconnectWithSessionID:(NSString *)_sid;
- (FBMetaData *)disconnectAll;
- (FBMetaData *)disconnectDefault;
- (FBMetaData *)disconnectCurrent;
- (FBMetaData *)setConnection:(NSString *)_sid;
- (FBMetaData *)setConnectionToDefault;

- (void)close;

- (void *)fbcConnection;

/* session */

- (FBMetaData *)createSession:(NSString *)_sn
  sessionUser:(NSString *)_user
  password:(NSString *)_pwd
  systemUser:(NSString *)_login;

/* SQL execution */

- (FBMetaData *)executeDirectSQL:(NSString *)_sql;

/* fetching */

- (NSValue *)fetch:(unsigned)_rowCount handle:(NSString *)_handle;
- (NSValue *)fetchWithHandle:(NSString *)_handle;
- (FBMetaData *)cancelFetch:(NSString *)_handle;

/* transactions */

- (FBMetaData *)commit;
- (FBMetaData *)rollback;

/* replication stuff */

- (unsigned)transactionVersion;
- (FBMetaData *)setTransactionVersion:(unsigned)_version;
- (FBMetaData *)setSessionDefaultsFromReplicator:(NSString *)_defaults;

/* blobs */

- (FBBlobHandle *)writeBLOB:(NSData *)_blob;
- (NSData *)readBLOB:(FBBlobHandle *)_handle;

@end

#endif /* __FrontBase_FBDatabaseConnection_H__ */
