/* 
   FBRowHandler.h

   Copyright (C) 1999 MDlink online service center GmbH and Helge Hess

   Author: Helge Hess (helge.hess@mdlink.de)

   This file is part of the FB Adaptor Library

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
// $Id: FBRowHandler.h,v 1.2 1999/11/02 23:32:41 helge Exp $

#ifndef __FrontBase_FBRowHandler_H__
#define __FrontBase_FBRowHandler_H__

#import <Foundation/NSEnumerator.h>

@class NSValue, NSDictionary;
@class FBDatabaseConnection, FBMetaData;

@interface FBRowHandler : NSEnumerator
{
  FBMetaData *metaData;
  void     *rows;
  unsigned colCount;
  int      rowCount;
  int      currentRow;
  unsigned *columnDataTypes;
  id       *columnLabels;
}

- (id)initWithData:(NSValue *)_rawData metaData:(FBMetaData *)_md;

/* info */

- (unsigned)columnCount;
- (int)rowCount;
- (FBMetaData *)metaData;

/* rows */

- (NSDictionary *)firstRow;
- (NSDictionary *)nextRow;
- (NSDictionary *)rowAtIndex:(unsigned)_idx;

/* raw rows */

- (void **)firstRawRow;
- (void **)nextRawRow;
- (void **)rawRowAtIndex:(unsigned)_idx;

/* enumerator */

- (id)nextObject;

@end

@interface FBRowHandler(PrivateMethods)

- (void *)cRowHandler;

@end

#endif /* __FrontBase_FBRowHandler_H__ */
