/* 
   FBSQLExpression.m

   Copyright (C) 1999 MDlink online service center GmbH and Helge Hess

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the FB Adaptor Library

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
// $Id: FBSQLExpression.m,v 1.3 1999/11/02 23:32:37 helge Exp $

#include <Foundation/Foundation.h>
#include <eoaccess/eoaccess.h>
#include "FBSQLExpression.h"

@implementation FBSQLExpression

+ (Class)selectExpressionClass	{
  return [FBSelectSQLExpression class];
}

@end

@implementation FBSelectSQLExpression

- (id)selectExpressionForAttributes:(NSArray *)attributes
  lock:(BOOL)flag
  qualifier:(EOSQLQualifier *)qualifier
  fetchOrder:(NSArray *)fetchOrder
  channel:(EOAdaptorChannel *)channel
{
  self->lock = flag;
  
  return [super selectExpressionForAttributes:attributes
                lock:flag
                qualifier:qualifier
                fetchOrder:fetchOrder
                channel:channel];
}

- (NSString *)fromClause {
  NSMutableString *fromClause = [NSMutableString stringWithCString:"\nFROM "];
  NSEnumerator    *enumerator = [fromListEntities objectEnumerator];
  BOOL            first       = YES;
  id              key;

  // Compute the FROM list from all the aliases found in
  // entitiesAndPropertiesAliases dictionary. Note that this dictionary
  // contains entities and relationships. The last ones are there for
  // flattened attributes over reflexive relationships.
  
  while((key = [enumerator nextObject])) {
    if(first) first = NO;
    else      [fromClause appendString:@", "];

    [fromClause appendFormat:@"%@ %@",
                  [key isKindOfClass:[EORelationship class]]
                  ? [[key destinationEntity] externalName] // flattened attribute
                  : [key externalName],                    // EOEntity
                  [entitiesAndPropertiesAliases objectForKey:key]];
    
    if (lock) [fromClause appendString:@" HOLDLOCK"];
  }

  return fromClause;
}

@end

void __link_FBSQLExpression() {
  // used to force linking of object file
  __link_FBSQLExpression();
}
